WWW=$(HOME)/www/noweb/examples
SHELL=/bin/sh
NOTANGLE=nountangle -m3
NOWEAVE=noweave

.SUFFIXES: .i3 .m3 .nw .tex .dvi .html
.nw.html:
	$(NOWEAVE) -filter btdefn -index -html $*.nw > $*.html
.nw.tex:
	$(NOWEAVE) -index -filter btdefn $*.nw > $*.tex
.nw.i3:
	$(NOTANGLE) -Rinterface -L'<* LINE %L "%F" *>%N' $*.nw > $*.i3
.nw.m3:
	$(NOTANGLE) -L'<* LINE %L "%F" *>%N' $*.nw > $*.m3
.tex.dvi:
	latex '\scrollmode \input '"$*"; while grep -s 'Rerun to get cross-references right' $*.log; do latex '\scrollmode \input '"$*"; done

HTML=breakmodel.html compress.html dag.html graphs.html mipscoder.html primes.html \
	scanner.html test.html tree.html wc.html wcni.html
DVI=compress.dvi dag.dvi mipscoder.dvi scanner.dvi tree.dvi test.dvi wc.dvi


texonly: $(DVI)

www: $(HTML)
	copy -v $(HTML) $(WWW)
	copy -v README.h $(WWW)/index.html

clean:
	$(RM) *~ *.aux *.tex *.dvi *.log *.html *.toc

clobber: clean

compress.html: compress.nw
	$(NOWEAVE) -index -html $< > $@
compress.tex: compress.nw
	$(NOWEAVE) -index $< > $@
dag.html: dag.nw
	$(NOWEAVE) -index -html $< > $@
dag.tex: dag.nw
	$(NOWEAVE) -index $< > $@
mipscoder.html: mipscoder.nw
	$(NOWEAVE) -index -html $< > $@
mipscoder.tex: mipscoder.nw
	$(NOWEAVE) -index $< > $@
scanner.html: scanner.nw
	$(NOWEAVE) -index -html $< > $@
scanner.tex: scanner.nw
	$(NOWEAVE) -index $< > $@
tree.html: tree.nw
	$(NOWEAVE) -index -html $< > $@
tree.tex: tree.nw
	$(NOWEAVE) -index $< > $@
test.html: test.nw
	$(NOWEAVE) -html $< > $@
test.tex: test.nw
	$(NOWEAVE) $< > $@
wc.html: wc.nw2html
	$(NOWEAVE) -filter btdefn -index -html -n $< > $@
wcni.html: wc.nw2html
	$(NOWEAVE) -filter btdefn -x     -html -n $< > $@
wc.tex: wc.nw
	$(NOWEAVE) -filter btdefn -index $< > $@
